Also accept the user if the specified group is the user's primary group.
diff -uNr Linux-PAM-0.75/modules/pam_wheel/pam_wheel.c Linux-PAM-0.75/modules/pam_wheel/pam_wheel.c
--- Linux-PAM-0.75/modules/pam_wheel/pam_wheel.c	Sun Nov 26 02:40:04 2000
+++ Linux-PAM-0.75/modules/pam_wheel/pam_wheel.c	Tue Jul 10 00:14:23 2001
@@ -60,7 +60,7 @@
 
 static int is_on_list(char * const *list, const char *member)
 {
-    while (*list) {
+    while (list && *list) {
         if (strcmp(*list, member) == 0)
             return 1;
         list++;
@@ -103,17 +103,17 @@
 }
 
 
-/* --- authentication management functions (only) --- */
+/* --- authentication management functions --- */
 
 PAM_EXTERN
 int pam_sm_authenticate(pam_handle_t *pamh,int flags,int argc
 			,const char **argv)
 {
-     int ctrl;
-     const char *username;
-     char *fromsu;
-     struct passwd *pwd, *tpwd;
-     struct group *grp;
+     int ctrl = 0;
+     const char *username = NULL;
+     char *fromsu = NULL;
+     struct passwd *pwd = NULL, *tpwd = NULL;
+     struct group *grp = NULL;
      int retval = PAM_AUTH_ERR;
      char use_group[BUFSIZ];
     
@@ -158,7 +158,8 @@
          fromsu = tpwd->pw_name;
      } else {
          fromsu = getlogin();
-         if (!fromsu) {
+         tpwd = getpwnam(fromsu);
+         if (!fromsu || !tpwd) {
              if (ctrl & PAM_DEBUG_ARG)
                 _pam_log(LOG_NOTICE,"who is running me ?!");
              return PAM_SERVICE_ERR;
@@ -172,7 +173,7 @@
      } else
 	 grp = getgrnam(use_group);
         
-     if (!grp || !grp->gr_mem) {
+     if (!grp || (!grp->gr_mem && (tpwd->pw_gid != grp->gr_gid))) {
         if (ctrl & PAM_DEBUG_ARG) {
             if (!use_group[0])
                 _pam_log(LOG_NOTICE,"no members in a GID 0 group");
@@ -189,7 +190,7 @@
             return PAM_AUTH_ERR;
      }
         
-     if (is_on_list(grp->gr_mem, fromsu)) {
+     if (is_on_list(grp->gr_mem, fromsu) || (tpwd->pw_gid == grp->gr_gid)) {
         if (ctrl & PAM_DEBUG_ARG)
             _pam_log(LOG_NOTICE,"Access %s to '%s' for '%s'",
                      (ctrl & PAM_DENY_ARG)?"denied":"granted",
